 
//Copyright (C) 1998-2013 MKTMK Moscow, Russia
//http://sourceforge.net/projects/obasic/
//http://mktmk.narod.ru
//e-mail: mktmk<at>narod.ru
//e-mail: openbasicsoft<at>gmail.com
//interpreter Open Basic (OB).

#include <ob.h>

namespace OB_NAMESPACE_FOR_OB{

//here is ob_lex::function (operators)

void ob_lex::operprint(){

ob_ostream* o=&(ptrbasic->out);

get_lex();
if(currentlex==ob_lex::SHARP){

get_lex();

ob_type_filenum number=gettypevalue<ob_int>();

ob_base_file* tmpfile;
if((tmpfile=ptrbasic->table_project.findfile(number))==OB_NULL) OB_ERR(ob_err38);
tmpfile->get_stream(&o);
}//if print to file

if(o->iszero()==true) OB_ERR(ob_err108);

typelex prevlex;

for(;;){

prevlex=currentlex;

m2:

switch(currentlex){

case ob_lex::COMMA:
o->put(ob_const_tab);

case ob_lex::SEMICOLON:
get_lex();
goto m2;

case ob_lex::OPERATOR:
case ob_lex::EOL:
case ob_lex::ENDPROGRAMM:
goto m1;
default:break;
}//switch

ob_savewrapper tmp;
expr(&tmp);
tmp.tostream(o);

}//for
m1:

putbacklex();

if((prevlex!=ob_lex::SEMICOLON)&&(prevlex!=ob_lex::COMMA)) o->putendl();
}

void ob_lex::dopinput(ob_lex* lex){

if(lex->iszero()==true) OB_ERR(ob_err109);

ob_savewrapper* tmp;
ob_savewrapper  tmp1;

for(;;){

switch(currentlex){
case ob_lex::OLDARRAY:
case ob_lex::OLDVARIABLE:
case ob_lex::NEWNAME:

tmp=extractvar()->get();

  switch(lex->currentlex){
  case ob_lex::ENDPROGRAMM:
  goto m1;

  case ob_lex::EOL:
  case ob_lex::COMMA:
  lex->get_lex();
  break;

  default:break;
  }//switch lex

tmp1.clear();
lex->expr(&tmp1);

tmp->asg(&tmp1);

get_lex();
break;

case ob_lex::COMMA:
get_lex();
break;

default:
goto m1;
}//switch baselex

}//for
m1:;
}

void ob_lex::operinput(){

ob_lex* r=&ptrbasic->readlex;

get_lex();

if(currentlex==ob_lex::SHARP){

get_lex();

ob_type_filenum number=gettypevalue<ob_int>();

ob_base_file* tmpfile;
if((tmpfile=ptrbasic->table_project.findfile(number))==OB_NULL) OB_ERR(ob_err38);

ob_istream* ptr;
tmpfile->get_stream(&ptr);

*(ptrbasic->read_from_file_lex.get_input_stream())=*ptr;
r=&ptrbasic->read_from_file_lex;
}//if read from file

r->get_lex();
dopinput(r);
}

void
ob_lex::findkeywordforif(ob_type_namestatic* kwrd1,ob_type_namestatic* kwrd2){

ob_type_streampos one(getposition());

ob_type_countnestedoperator nestedcount=ob_type_countnestedoperator();

for(;;){
get_lex();

if((currentlex==ob_lex::OPERATOR)&&((*getstring())==ptrbasic->ob_REMkwrd)){
getcurrentoperator()->run_for_work(this);
continue;
}//if

if(currentlex==ob_lex::ENDPROGRAMM){
setposition(one);
OB_ERR(ob_err70)
}//if

if(kwrd1!=OB_NULL){
  if(((*getstring())==(*kwrd1))&&(nestedcount==0)){
  get_lex();
  break;
  }//if
}//if

if(kwrd2!=OB_NULL){
  if(((*getstring())==(*kwrd2))&&(nestedcount==0)){
  get_lex();
  break;
  }//if
}//if

if((*getstring())==ptrbasic->ob_THENkwrd){
get_lex();
if(currentlex==ob_lex::EOL) ++nestedcount;
}//if

if((*getstring())==ptrbasic->ob_ENDIFkwrd){
  if(nestedcount!=ob_type_countnestedoperator()){
  --nestedcount;
  }//if
  else{
  setposition(one);
  OB_ERR(ob_err70)
  }//else
}//if

}//for

}

void ob_lex::operelse(){
findkeywordforif(&(ptrbasic->ob_ENDIFkwrd),OB_NULL);
}

void ob_lex::operendif(){
get_lex();
}

void ob_lex::operif(){

ob_var::ob_type_if currentlexif;

ob_savewrapper left;

get_lex();
expr(&left);

{//start blocks
switch(currentlex){

case ob_lex::LESS:
currentlexif=ob_var::LESSIF;
get_lex();

if(currentlex==ob_lex::ASSIGN){
currentlexif=ob_var::LESSEQVIF;
get_lex();
}//if
else{
  if(currentlex==ob_lex::GREAT){
  currentlexif=ob_var::NOTEQVIF;
  get_lex();
  }//if
}//else
break;

case ob_lex::GREAT:
currentlexif=ob_var::GREATIF;
get_lex();

if(currentlex==ob_lex::ASSIGN){
currentlexif=ob_var::GREATEQVIF;
get_lex();
}//if
break;

case ob_lex::ASSIGN:
currentlexif=ob_var::EQVIF;
get_lex();
break;

default:OB_ERR(ob_err13);break;
}//switch
}//end blocks

ob_savewrapper right;
expr(&right);

if((*getstring())!=ptrbasic->ob_THENkwrd) OB_ERR(ob_err14);

get_lex();
bool flform1;
if(currentlex!=ob_lex::EOL) flform1=true; else flform1=false;

bool flcondition=left.compare(&right,currentlexif);

if(flform1==true){
  if(flcondition==false){
  findeol();
  }//if
  else{}//else
}//if
else{
  if(flcondition==false){

  findkeywordforif(&(ptrbasic->ob_ELSEkwrd),&(ptrbasic->ob_ENDIFkwrd));

  }//if

  else{}//else
}//else

}

void ob_lex::operfor(){

ob_varbase* tmp;

ob_savewrapper zero(new ob_int(ob_type_int()));

get_lex();

switch(currentlex){
case ob_lex::OLDARRAY:
case ob_lex::OLDVARIABLE:
case ob_lex::NEWNAME:
tmp=extractvar();
workvariable(tmp->get());
break;
default:OB_ERR(ob_err18)
}//switch

if((*getstring())!=ptrbasic->ob_TOkwrd) OB_ERR(ob_err19);

ob_type_name nameforfor=tmp->bigname();

get_lex();

ob_savewrapper last,step;

expr(&last);

//without STEP keyword STEP=1
if((*getstring())!=ptrbasic->ob_STEPkwrd){
step.setptr(new ob_int(1));
}//if
else{
get_lex();
expr(&step);
}//else

//check if ob_forfor object already exist in tableforfor
//previousptr for support step mode debugger
ob_forfor* tmpptr1=ptrbasic->get_common_table()->createforfor(&nameforfor,&last,&step,previousptr,&in);

//check first pass, STEP is present in check
if(tmpptr1->check(tmp->get())==false){

ob_type_streampos one(getposition());

//delete comment if NEXT may be located before FOR but performance decrease
//restore();

  for(;;){

  get_lex();//find NEXT keyword for this FOR

  if(currentlex==ob_lex::ENDPROGRAMM){
  setposition(one);
  OB_ERR(ob_err66)
  }

  if((currentlex==OPERATOR)&&((*getstring())==ptrbasic->ob_NEXTkwrd)){

  ob_varbase* tmp1;
  get_lex();

  switch(currentlex){
  case ob_lex::OLDARRAY:
  case ob_lex::OLDVARIABLE:
  tmp1=extractvar();
  break;
  case ob_lex::NEWNAME:continue;
  default:OB_ERR(ob_err69)
  }//switch

  ob_type_name nameforfor1=tmp1->bigname();
  
    if(nameforfor==nameforfor1){
    get_lex();
    goto m1;
    }//if
    
  }//if

  }//for
}//if
m1:;
}

void ob_lex::opernext(){

ob_varbase* tmp;
get_lex();

switch(currentlex){
case ob_lex::OLDARRAY:
case ob_lex::OLDVARIABLE:
tmp=extractvar();
break;
default:OB_ERR(ob_err69)
}//switch

ob_type_name nameforfor=tmp->bigname();

ob_forfor* forptr=ptrbasic->get_common_table()->findforfor(&nameforfor,&in);
if(forptr==OB_NULL) OB_ERR(ob_err71)

forptr->add(tmp->get());
if(forptr->check(tmp->get())==true){
setposition(forptr);
}//if

get_lex();
}

void ob_lex::opergo(typego typego){

get_lex();

ob_data_for_jump_local* current;

current=ptrbasic->get_common_table()->findlabel(getstring(),&in);
if(current==OB_NULL) OB_ERR(ob_err12);

if(typego==GOSUB){

ob_type_listlength mng=ptrbasic->get_max_nested_gosub();
ob_type_listlength mng1=ptrbasic->get_common_table()->get_gousub_count();

if((mng!=0)&&(mng==mng1)) OB_ERR(ob_err103);

ptrbasic->get_common_table()->put_return_data_to_stack(&in);

}//if

setposition(current);

get_lex();
}

void ob_lex::opergoto(){opergo(GOTO);}
void ob_lex::opergosub(){opergo(GOSUB);}

void ob_lex::operreturn(){

ob_type_listlength mng1=ptrbasic->get_common_table()->get_gousub_count();
if(mng1==ob_type_listlength()) OB_ERR(ob_err17);

ob_data_for_jump_global data_for_return_operator;

ptrbasic->get_common_table()->get_return_data_from_stack(&data_for_return_operator);

setposition(&data_for_return_operator);

get_lex();
}

void ob_lex::operlet(){get_lex();}

void ob_lex::operdim(){

for(;;){

get_lex();

if(!((currentlex==ob_lex::OLDARRAY)||(currentlex==ob_lex::NEWNAME)))
OB_ERR(ob_err24);

ob_type_name namearray;

namearray=*getstring();

ob_type_namestatic namearraystatic(namearray.c_str(),namearray.getcount());

ob_type_dim ptrdimcurrent;
getsizearray(&ptrdimcurrent);

ptrbasic->createarray(&namearraystatic,&ptrdimcurrent,&in);

get_lex();
if(currentlex!=ob_lex::COMMA) break;
}//for
}

void ob_lex::getsizearray(ob_type_dim* ptrdimcurrent){

ob_type_arraysize tmparraydimention[ob_maxarraydimention];

ob_type_arraydimension i;
ob_type_arraydimension kr;
get_lex();

if(currentlex!=ob_lex::LP) OB_ERR(ob_err72);

get_lex();

if(currentlex==ob_lex::RP) OB_ERR(ob_err31);

for(kr=0;;++kr){

if(kr==ob_maxarraydimention) OB_ERR(ob_err26);

tmparraydimention[kr]=gettypevalue<ob_int>();

if(tmparraydimention[kr]<=0) OB_ERR(ob_err29);

if(currentlex==ob_lex::RP){
++kr;
break;
}//if

if(currentlex!=ob_lex::COMMA) OB_ERR(ob_err27);
get_lex();
}//for

ptrdimcurrent->recount(kr);

for(i=0;i!=kr;++i){
(*ptrdimcurrent)[i]=tmparraydimention[i];
}//for

}

void ob_lex::operstop(){
ptrbasic->clrtabl(ob_obasic::NOOVERLAY);
get_lex();
}

void ob_lex::operend(){
ptrbasic->setendoperatordetect(true);
operstop();
}

void ob_lex::findeol(){

ob_type_char ch;

while(1){

in.get(ch);

if(in.eof()){
currentlex=ENDPROGRAMM;
break;
}//if

if(!in.good()) OB_ERR(ob_err9);

if(ob_iseol<ob_type_char>(ch)==true){
if(ch==ob_const_cr) findother(ob_const_lf);
if(ch==ob_const_lf) findother(ob_const_cr);
format_data(ch,EOL);
break;
}//if

}//while

}

void ob_lex::operrem(){
findeol();
}

void ob_lex::operopen(){

ios::openmode mode;

get_lex();

ob_varbase* tmp1;

ob_savewrapper tmp;

switch(currentlex){
case ob_lex::OLDARRAY:
case ob_lex::OLDVARIABLE:
tmp1=extractvarwithoutcreate();
tmp.setptr(tmp1->get()->duplicate());
get_lex();
break;
case ob_lex::STRING:

if(getstring()->getcount()<=3) OB_ERR(ob_err80)

expr(&tmp);//expr eliminate quote from string - file name
break;
default:OB_ERR(ob_err84)
}//switch

ob_type_char* ret;

tmp.cast(&ret);

ob_type_string filename(ret);

if((*getstring())!=ptrbasic->ob_FORkwrd) OB_ERR(ob_err33);

get_lex();

if((*getstring())==ptrbasic->ob_INPUTkwrd) mode=ios::in|ios::binary;
else
if((*getstring())==ptrbasic->ob_OUTPUTkwrd) mode=ios::out;
else
OB_ERR(ob_err34);

get_lex();
if((*getstring())!=ptrbasic->ob_ASkwrd) OB_ERR(ob_err35);

get_lex();

if((*getstring())!=ptrbasic->ob_FILEkwrd) OB_ERR(ob_err35);

get_lex();
if((*getstring())!=ptrbasic->ob_SHARPkwrd) OB_ERR(ob_err35);

get_lex();

ob_type_filenum number=gettypevalue<ob_int>();

ob_filefind filefind(number);

ptrbasic->table_project.open_file(number,mode,&filename);
}

void ob_lex::operclose(){

get_lex();

if(currentlex==ob_lex::EOL){
ptrbasic->table_project.cleartablefile();
get_lex();
}//if
else{
  for(;;){
  if(currentlex==ob_lex::SHARP)
  get_lex();

  ob_type_filenum number=gettypevalue<ob_int>();

  ptrbasic->table_project.close_file(number);

  if(currentlex!=ob_lex::COMMA) break;
  get_lex();
  }//for
}//else
}

void ob_lex::operkill(){

for(;;){
get_lex();                                    

ob_savewrapper tmp;
expr(&tmp);//expr eliminate quote from string - file name

ob_type_char* ret;

tmp.cast(&ret);

#ifndef OB_USER_WCHAR

remove(ret);

#else

ob_type_string_char_small sfn;
wchar2char(&sfn,ret);
remove(sfn.c_str());

#endif

if(currentlex!=ob_lex::COMMA) break;
}//for
}

void ob_lex::operread(){
get_lex();
dopinput(&(ptrbasic->datalex));
}

void ob_lex::operdata(){
findeol();
}

void ob_lex::operrestore(){
ptrbasic->datalex.restore();
get_lex();
}

void ob_lex::operrandomize(){
srand((ob_type_srandargument)time(OB_NULL));
get_lex();
}

//for version 1.91
void ob_lex::opersub(){
get_lex();
}

void ob_lex::operendsub(){
get_lex();
}

void ob_lex::operexitsub(){
get_lex();
}

void ob_lex::opercheckload_run(){
findeol();
}

void ob_lex::opercheckload_load(){

ob_savewrapper tmp;

get_lex();
if(currentlex!=ob_lex::STRING) OB_ERR(ob_err105);

expr(&tmp);

ob_type_string* s1=tmp.getstring();

if(s1==OB_NULL) OB_ERR(ob_err105);

ob_type_namestatic str1(s1);

ob_type_name* check_load_string=ptrbasic->table_project.find_checkloadstring(&str1);

if(check_load_string!=OB_NULL){

ptrbasic->set_flag_checkload(true);

}//if
else{

ob_type_wrapper_name wrn(new ob_type_name(str1));

ptrbasic->table_project.put_checkloadstring(&str1);

}//else

}

}//end namespace 
