 
//Copyright (C) 1998-2013 MKTMK Moscow, Russia
//http://sourceforge.net/projects/obasic/
//http://mktmk.narod.ru
//e-mail: mktmk<at>narod.ru
//e-mail: openbasicsoft<at>gmail.com
//interpreter Open Basic (OB).

#include <ob.h>

namespace OB_NAMESPACE_FOR_OB{

void ob_lex::format_data(ob_type_char ch,typelex tl){

ob_type_char *p=currentlexasstring.c_str();
ob_type_stringsize currentlexstrlength=ob_type_stringsize();

p[currentlexstrlength]=ch;
++currentlexstrlength;
p[currentlexstrlength]=ob_const_endstring;
++currentlexstrlength;

currentlexasnamestatic.set(currentlexasstring.c_str(),currentlexstrlength);

currentlex=tl;
}

ob_lex::typelex ob_lex::get_lex(){

m20:

bool flfloat=false;
bool flhex=false;
ob_type_char ch;
ob_type_char ch1;
ob_type_char *p=currentlexasstring.c_str();
ob_type_stringsize currentlexstrlength=0;

if(in.iszero()==true) OB_ERR(ob_err9);

previousptr=in.getposition();

for(;;){

in.get(ch);

if(in.eof()){
return currentlex=ENDPROGRAMM;
}//if

if(!in.good()) OB_ERR(ob_err9);

if(ob_isspace<ob_type_char>(ch)==false) break;
}//for

if(ob_iseol<ob_type_char>(ch)==true){

if(ch==ob_const_cr) findother(ob_const_lf);
if(ch==ob_const_lf) findother(ob_const_cr);

format_data(ch,EOL);

return currentlex;
}//if

if(ch==ob_const_bslash){

while(1){

in.get(ch);

if(in.eof()){
return currentlex=ENDPROGRAMM;
}//if

if(!in.good()) OB_ERR(ob_err9);

if(ob_iseol<ob_type_char>(ch)==true){
if(ch==ob_const_cr) findother(ob_const_lf);
if(ch==ob_const_lf) findother(ob_const_cr);
goto m20;
}//if

}//while

}//if

switch(ch){

#ifdef OB_USER_WCHAR
case ob_byte_order_mark1: format_data(ch,BYTE_ORDER_MARK1); return currentlex;
#endif

case ob_const_sharp   :format_data(ch,SHARP);      return currentlex;
case ob_const_at      :format_data(ch,BREAKPOINT); return currentlex;
case ob_const_equ     :format_data(ch,ASSIGN);     return currentlex;
case ob_const_asterisk:format_data(ch,MUL);        return currentlex;
case ob_const_slash   :format_data(ch,DIV);        return currentlex;
case ob_const_plus    :format_data(ch,PLUS);       return currentlex;
case ob_const_minus   :format_data(ch,MINUS);      return currentlex;
case ob_const_pow     :format_data(ch,POWER);      return currentlex;
case ob_const_lp      :format_data(ch,LP);         return currentlex;
case ob_const_rp      :format_data(ch,RP);         return currentlex;
case ob_const_sc      :format_data(ch,SEMICOLON);  return currentlex;
case ob_const_comma   :format_data(ch,COMMA);      return currentlex;
case ob_const_lp1     :format_data(ch,LESS);       return currentlex;
case ob_const_rp1     :format_data(ch,GREAT);      return currentlex;

case ob_const_quotes : //code "
case ob_const_quotes1: //code '
ch1=ch;

while(1){
  p[currentlexstrlength]=ch;

  ++currentlexstrlength;
  if(currentlexstrlength==ob_maxlengthstring){
  setposition(previousptr);
  OB_ERR(ob_err6);
  }//if

  in.get(ch);

  if(in.eof()){
  setposition(previousptr);
  OB_ERR(ob_err57);
  }//if

  if(!in.good()) OB_ERR(ob_err9);

  if(ch==ch1) break;
}//while

p[currentlexstrlength]=ch;
++currentlexstrlength;

p[currentlexstrlength]=ob_const_endstring;
++currentlexstrlength;

currentlexasnamestatic.set(currentlexasstring.c_str(),currentlexstrlength);
return currentlex=STRING;

case ob_const_point:
flfloat=true;
case ob_const_0:case ob_const_1:case ob_const_2:case ob_const_3:
case ob_const_4:case ob_const_5:case ob_const_6:case ob_const_7:
case ob_const_8:case ob_const_9:

while(1){
  p[currentlexstrlength]=ch;

  ++currentlexstrlength;
  if(currentlexstrlength==ob_maxlengthstring){
  setposition(previousptr);
  OB_ERR(ob_err6);
  }//if

  in.get(ch);

  if(in.eof())   break;
  if(!in.good()) OB_ERR(ob_err9);

  if((ch==ob_const_point)&&(flfloat==true)) OB_ERR(ob_err54);
  if(ch==ob_const_point) flfloat=true;

  if(((ch==ob_const_hex)||(ch==ob_const_HEX))&&(flhex==true)) OB_ERR(ob_err55);
  if((ch==ob_const_hex)||(ch==ob_const_HEX)){
  if((p[0]!=ob_const_0)||(currentlexstrlength!=1)) OB_ERR(ob_err55);
  flhex=true;
  }//if

  if((flhex==true)&&(flfloat==true)) OB_ERR(ob_err56);

  switch(ch){
  case ob_const_point:
  case ob_const_hex:
  case ob_const_HEX:
  case ob_const_a:
  case ob_const_b:
  case ob_const_c:
  case ob_const_d:
  case ob_const_e:
  case ob_const_f:
  case ob_const_A:
  case ob_const_B:
  case ob_const_C:
  case ob_const_D:
  case ob_const_E:
  case ob_const_F:
  case ob_const_0:
  case ob_const_1:
  case ob_const_2:
  case ob_const_3:
  case ob_const_4:
  case ob_const_5:
  case ob_const_6:
  case ob_const_7:
  case ob_const_8:
  case ob_const_9:
  break;
  default:
  in.putback();
  goto m10;
  }//switch

}//while

m10:

p[currentlexstrlength]=ob_const_endstring;
++currentlexstrlength;

currentlexasnamestatic.set(currentlexasstring.c_str(),currentlexstrlength);
if(flfloat==true) return currentlex=FLOATNUMBER;
else
if(flhex==true)   return currentlex=HEXINTNUMBER;
else
                  return currentlex=DECINTNUMBER;

default:

if(ob_isdelim<ob_type_char>(ch)==true){
return currentlex=BAD;
}//if

while(1){
  p[currentlexstrlength]=ch;

  ++currentlexstrlength;
  if(currentlexstrlength==ob_maxlengthstring){
  setposition(previousptr);
  OB_ERR(ob_err6);
  }//if

  in.get(ch);

  if(in.eof())   break;
  if(!in.good()) OB_ERR(ob_err9);

  if(ob_isdelim<ob_type_char>(ch)==true){
  break;
  }//if

}//while

p[currentlexstrlength]=ob_const_endstring;
++currentlexstrlength;

currentlexasnamestatic.set(currentlexasstring.c_str(),currentlexstrlength);

if(ch==ob_const_colon){
currentlex=LABEL; 
return currentlex;
}//if

in.putback();//if do not LABEL detect do not insert delim from input stream

currentoperator=ptrbasic->findoperator(&currentlexasnamestatic);
if(currentoperator!=OB_NULL) return currentlex=OPERATOR;

currentfunction=ptrbasic->table_system.findfun(&currentlexasnamestatic);
if(currentfunction!=OB_NULL) return currentlex=FUNC;

currentvar=ptrbasic->get_common_table()->findvar(&currentlexasnamestatic,&in);
if(currentvar!=OB_NULL) return currentlex=OLDVARIABLE;

currentarray=ptrbasic->get_common_table()->findarray(&currentlexasnamestatic,&in);
if(currentarray!=OB_NULL) return currentlex=OLDARRAY;

currentlex=NEWNAME; 
return currentlex;
}//switch
}

}//end namespace
